---
title: Reorder ticket creation rules
description: Datadog, the leading service for cloud-scale monitoring.
breadcrumbs: Docs > API Reference > Security Monitoring
---

> For the complete documentation index, see [llms.txt](https://docs.datadoghq.com/llms.txt).

# Reorder ticket creation rules{% #reorder-ticket-creation-rules %}
Copy pageCopied
{% tab title="v2" %}
**Note**: This endpoint is in Preview and is subject to change. If you have any feedback, contact [Datadog support](https://docs.datadoghq.com/help/).
| Datadog site      | API endpoint                                                                                         |
| ----------------- | ---------------------------------------------------------------------------------------------------- |
| ap1.datadoghq.com | POST https://api.ap1.datadoghq.com/api/v2/security/findings/automation/ticket_creation_rules/reorder |
| ap2.datadoghq.com | POST https://api.ap2.datadoghq.com/api/v2/security/findings/automation/ticket_creation_rules/reorder |
| app.datadoghq.eu  | POST https://api.datadoghq.eu/api/v2/security/findings/automation/ticket_creation_rules/reorder      |
| app.ddog-gov.com  | POST https://api.ddog-gov.com/api/v2/security/findings/automation/ticket_creation_rules/reorder      |
| us2.ddog-gov.com  | POST https://api.us2.ddog-gov.com/api/v2/security/findings/automation/ticket_creation_rules/reorder  |
| uk1.datadoghq.com | POST https://api.uk1.datadoghq.com/api/v2/security/findings/automation/ticket_creation_rules/reorder |
| app.datadoghq.com | POST https://api.datadoghq.com/api/v2/security/findings/automation/ticket_creation_rules/reorder     |
| us3.datadoghq.com | POST https://api.us3.datadoghq.com/api/v2/security/findings/automation/ticket_creation_rules/reorder |
| us5.datadoghq.com | POST https://api.us5.datadoghq.com/api/v2/security/findings/automation/ticket_creation_rules/reorder |

### Overview

Reorder the list of ticket creation rules for the current organization. This endpoint requires the `security_pipelines_write` permission.

### Request

#### Body Data (required)



{% tab title="Model" %}

| Parent field | Field                  | Type     | Description                                                                               |
| ------------ | ---------------------- | -------- | ----------------------------------------------------------------------------------------- |
|              | data [*required*] | [object] | The ordered list of all ticket creation rules; every rule must be included.               |
| data         | id [*required*]   | uuid     | The ID of the automation rule.                                                            |
| data         | type [*required*] | enum     | The JSON:API type for ticket creation rules. Allowed enum values: `ticket_creation_rules` |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": [
    {
      "id": "00000000-0000-0000-0000-000000000000",
      "type": "ticket_creation_rules"
    }
  ]
}
```

{% /tab %}

### Response

{% tab title="200" %}
Successfully reordered the ticket creation rules
{% tab title="Model" %}
The body of the ticket creation rule reorder request.

| Parent field | Field                  | Type     | Description                                                                               |
| ------------ | ---------------------- | -------- | ----------------------------------------------------------------------------------------- |
|              | data [*required*] | [object] | The ordered list of all ticket creation rules; every rule must be included.               |
| data         | id [*required*]   | uuid     | The ID of the automation rule.                                                            |
| data         | type [*required*] | enum     | The JSON:API type for ticket creation rules. Allowed enum values: `ticket_creation_rules` |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": [
    {
      "id": "00000000-0000-0000-0000-000000000000",
      "type": "ticket_creation_rules"
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="400" %}
Bad Request
{% tab title="Model" %}
API error response.

| Parent field | Field                    | Type     | Description                                                                     |
| ------------ | ------------------------ | -------- | ------------------------------------------------------------------------------- |
|              | errors [*required*] | [object] | A list of errors.                                                               |
| errors       | detail                   | string   | A human-readable explanation specific to this occurrence of the error.          |
| errors       | meta                     | object   | Non-standard meta-information about the error                                   |
| errors       | source                   | object   | References to the source of the error.                                          |
| source       | header                   | string   | A string indicating the name of a single request header which caused the error. |
| source       | parameter                | string   | A string indicating which URI query parameter caused the error.                 |
| source       | pointer                  | string   | A JSON pointer to the value in the request document that caused the error.      |
| errors       | status                   | string   | Status code of the response.                                                    |
| errors       | title                    | string   | Short human-readable summary of the error.                                      |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="403" %}
Forbidden
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="422" %}
Unprocessable Entity
{% tab title="Model" %}
API error response.

| Parent field | Field                    | Type     | Description                                                                     |
| ------------ | ------------------------ | -------- | ------------------------------------------------------------------------------- |
|              | errors [*required*] | [object] | A list of errors.                                                               |
| errors       | detail                   | string   | A human-readable explanation specific to this occurrence of the error.          |
| errors       | meta                     | object   | Non-standard meta-information about the error                                   |
| errors       | source                   | object   | References to the source of the error.                                          |
| source       | header                   | string   | A string indicating the name of a single request header which caused the error. |
| source       | parameter                | string   | A string indicating which URI query parameter caused the error.                 |
| source       | pointer                  | string   | A JSON pointer to the value in the request document that caused the error.      |
| errors       | status                   | string   | Status code of the response.                                                    |
| errors       | title                    | string   | Short human-readable summary of the error.                                      |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="429" %}
Too many requests
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

### Code Example

##### 
                          \## default
# 
 \# Curl command curl -X POST "https://api.datadoghq.com/api/v2/security/findings/automation/ticket_creation_rules/reorder" \
-H "Accept: application/json" \
-H "Content-Type: application/json" \
-H "DD-API-KEY: ${DD_API_KEY}" \
-H "DD-APPLICATION-KEY: ${DD_APP_KEY}" \
-d @- << EOF
{
  "data": [
    {
      "id": "00000000-0000-0000-0000-000000000000",
      "type": "ticket_creation_rules"
    },
    {
      "id": "11111111-1111-1111-1111-111111111111",
      "type": "ticket_creation_rules"
    }
  ]
}
EOF 
                        
##### 

```go
// Reorder ticket creation rules returns "Successfully reordered the ticket creation rules" response

package main

import (
	"context"
	"encoding/json"
	"fmt"
	"os"

	"github.com/DataDog/datadog-api-client-go/v2/api/datadog"
	"github.com/DataDog/datadog-api-client-go/v2/api/datadogV2"
	"github.com/google/uuid"
)

func main() {
	// there is a valid "valid_ticket_creation_rule" in the system
	ValidTicketCreationRuleDataID := uuid.MustParse(os.Getenv("VALID_TICKET_CREATION_RULE_DATA_ID"))

	body := datadogV2.TicketCreationRuleReorderRequest{
		Data: []datadogV2.TicketCreationRuleReorderItem{
			{
				Id:   ValidTicketCreationRuleDataID,
				Type: datadogV2.TICKETCREATIONRULETYPE_TICKET_CREATION_RULES,
			},
		},
	}
	ctx := datadog.NewDefaultContext(context.Background())
	configuration := datadog.NewConfiguration()
	configuration.SetUnstableOperationEnabled("v2.ReorderSecurityFindingsAutomationTicketCreationRules", true)
	apiClient := datadog.NewAPIClient(configuration)
	api := datadogV2.NewSecurityMonitoringApi(apiClient)
	resp, r, err := api.ReorderSecurityFindingsAutomationTicketCreationRules(ctx, body)

	if err != nil {
		fmt.Fprintf(os.Stderr, "Error when calling `SecurityMonitoringApi.ReorderSecurityFindingsAutomationTicketCreationRules`: %v\n", err)
		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
	}

	responseContent, _ := json.MarshalIndent(resp, "", "  ")
	fmt.Fprintf(os.Stdout, "Response from `SecurityMonitoringApi.ReorderSecurityFindingsAutomationTicketCreationRules`:\n%s\n", responseContent)
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=go) and then save the example to `main.go` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" go run "main.go"
##### 

```java
// Reorder ticket creation rules returns "Successfully reordered the ticket creation rules" response

import com.datadog.api.client.ApiClient;
import com.datadog.api.client.ApiException;
import com.datadog.api.client.v2.api.SecurityMonitoringApi;
import com.datadog.api.client.v2.model.TicketCreationRuleReorderItem;
import com.datadog.api.client.v2.model.TicketCreationRuleReorderRequest;
import com.datadog.api.client.v2.model.TicketCreationRuleType;
import java.util.Collections;
import java.util.UUID;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = ApiClient.getDefaultApiClient();
    defaultClient.setUnstableOperationEnabled(
        "v2.reorderSecurityFindingsAutomationTicketCreationRules", true);
    SecurityMonitoringApi apiInstance = new SecurityMonitoringApi(defaultClient);

    // there is a valid "valid_ticket_creation_rule" in the system
    UUID VALID_TICKET_CREATION_RULE_DATA_ID = null;
    try {
      VALID_TICKET_CREATION_RULE_DATA_ID =
          UUID.fromString(System.getenv("VALID_TICKET_CREATION_RULE_DATA_ID"));
    } catch (IllegalArgumentException e) {
      System.err.println("Error parsing UUID: " + e.getMessage());
    }

    TicketCreationRuleReorderRequest body =
        new TicketCreationRuleReorderRequest()
            .data(
                Collections.singletonList(
                    new TicketCreationRuleReorderItem()
                        .id(VALID_TICKET_CREATION_RULE_DATA_ID)
                        .type(TicketCreationRuleType.TICKET_CREATION_RULES)));

    try {
      TicketCreationRuleReorderRequest result =
          apiInstance.reorderSecurityFindingsAutomationTicketCreationRules(body);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println(
          "Exception when calling"
              + " SecurityMonitoringApi#reorderSecurityFindingsAutomationTicketCreationRules");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=java) and then save the example to `Example.java` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" java "Example.java"
##### 

```python
"""
Reorder ticket creation rules returns "Successfully reordered the ticket creation rules" response
"""

from os import environ
from datadog_api_client import ApiClient, Configuration
from datadog_api_client.v2.api.security_monitoring_api import SecurityMonitoringApi
from datadog_api_client.v2.model.ticket_creation_rule_reorder_item import TicketCreationRuleReorderItem
from datadog_api_client.v2.model.ticket_creation_rule_reorder_request import TicketCreationRuleReorderRequest
from datadog_api_client.v2.model.ticket_creation_rule_type import TicketCreationRuleType

# there is a valid "valid_ticket_creation_rule" in the system
VALID_TICKET_CREATION_RULE_DATA_ID = environ["VALID_TICKET_CREATION_RULE_DATA_ID"]

body = TicketCreationRuleReorderRequest(
    data=[
        TicketCreationRuleReorderItem(
            id=VALID_TICKET_CREATION_RULE_DATA_ID,
            type=TicketCreationRuleType.TICKET_CREATION_RULES,
        ),
    ],
)

configuration = Configuration()
configuration.unstable_operations["reorder_security_findings_automation_ticket_creation_rules"] = True
with ApiClient(configuration) as api_client:
    api_instance = SecurityMonitoringApi(api_client)
    response = api_instance.reorder_security_findings_automation_ticket_creation_rules(body=body)

    print(response)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=python) and then save the example to `example.py` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" python3 "example.py"
##### 

```ruby
# Reorder ticket creation rules returns "Successfully reordered the ticket creation rules" response

require "datadog_api_client"
DatadogAPIClient.configure do |config|
  config.unstable_operations["v2.reorder_security_findings_automation_ticket_creation_rules".to_sym] = true
end
api_instance = DatadogAPIClient::V2::SecurityMonitoringAPI.new

# there is a valid "valid_ticket_creation_rule" in the system
VALID_TICKET_CREATION_RULE_DATA_ID = ENV["VALID_TICKET_CREATION_RULE_DATA_ID"]

body = DatadogAPIClient::V2::TicketCreationRuleReorderRequest.new({
  data: [
    DatadogAPIClient::V2::TicketCreationRuleReorderItem.new({
      id: VALID_TICKET_CREATION_RULE_DATA_ID,
      type: DatadogAPIClient::V2::TicketCreationRuleType::TICKET_CREATION_RULES,
    }),
  ],
})
p api_instance.reorder_security_findings_automation_ticket_creation_rules(body)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=ruby) and then save the example to `example.rb` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" rb "example.rb"
##### 

```rust
// Reorder ticket creation rules returns "Successfully reordered the ticket
// creation rules" response
use datadog_api_client::datadog;
use datadog_api_client::datadogV2::api_security_monitoring::SecurityMonitoringAPI;
use datadog_api_client::datadogV2::model::TicketCreationRuleReorderItem;
use datadog_api_client::datadogV2::model::TicketCreationRuleReorderRequest;
use datadog_api_client::datadogV2::model::TicketCreationRuleType;

#[tokio::main]
async fn main() {
    // there is a valid "valid_ticket_creation_rule" in the system
    let valid_ticket_creation_rule_data_id =
        uuid::Uuid::parse_str(&std::env::var("VALID_TICKET_CREATION_RULE_DATA_ID").unwrap())
            .expect("Invalid UUID");
    let body = TicketCreationRuleReorderRequest::new(vec![TicketCreationRuleReorderItem::new(
        valid_ticket_creation_rule_data_id.clone(),
        TicketCreationRuleType::TICKET_CREATION_RULES,
    )]);
    let mut configuration = datadog::Configuration::new();
    configuration.set_unstable_operation_enabled(
        "v2.ReorderSecurityFindingsAutomationTicketCreationRules",
        true,
    );
    let api = SecurityMonitoringAPI::with_config(configuration);
    let resp = api
        .reorder_security_findings_automation_ticket_creation_rules(body)
        .await;
    if let Ok(value) = resp {
        println!("{:#?}", value);
    } else {
        println!("{:#?}", resp.unwrap_err());
    }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=rust) and then save the example to `src/main.rs` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" cargo run
##### 

```typescript
/**
 * Reorder ticket creation rules returns "Successfully reordered the ticket creation rules" response
 */

import { client, v2 } from "@datadog/datadog-api-client";

const configuration = client.createConfiguration();
configuration.unstableOperations[
  "v2.reorderSecurityFindingsAutomationTicketCreationRules"
] = true;
const apiInstance = new v2.SecurityMonitoringApi(configuration);

// there is a valid "valid_ticket_creation_rule" in the system
const VALID_TICKET_CREATION_RULE_DATA_ID = process.env
  .VALID_TICKET_CREATION_RULE_DATA_ID as string;

const params: v2.SecurityMonitoringApiReorderSecurityFindingsAutomationTicketCreationRulesRequest =
  {
    body: {
      data: [
        {
          id: VALID_TICKET_CREATION_RULE_DATA_ID,
          type: "ticket_creation_rules",
        },
      ],
    },
  };

apiInstance
  .reorderSecurityFindingsAutomationTicketCreationRules(params)
  .then((data: v2.TicketCreationRuleReorderRequest) => {
    console.log(
      "API called successfully. Returned data: " + JSON.stringify(data)
    );
  })
  .catch((error: any) => console.error(error));
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=typescript) and then save the example to `example.ts` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" tsc "example.ts"
{% /tab %}
